#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "xpvs.h"

#define IDM_BUTTON1 (100)
#define IDM_PROGRESSBAR1 (101)

#define PROGRESS_MAX_VALUE (100)

TCHAR g_lpszClassName[] = TEXT("_Skelton_");
HWND g_hWnd = NULL;
HWND g_hButton = NULL;
HWND g_hProgressBar = NULL;


//////////////////////////////////////////////////////////////////////////


int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {

	WNDCLASSEX wcl;

	wcl.cbSize = sizeof(WNDCLASSEX);
	wcl.hInstance = hInstance;
	wcl.lpszClassName = g_lpszClassName;
	wcl.lpfnWndProc = WndProc;
	wcl.style = NULL;
	wcl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcl.hIconSm = NULL;
	wcl.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcl.lpszMenuName = NULL;
	wcl.cbClsExtra = 0;
	wcl.cbWndExtra = 0;
	wcl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

	if(!RegisterClassEx(&wcl)) {
		return FALSE;
	}

	g_hWnd = CreateWindowEx( 
		0, 	
		g_lpszClassName,
		TEXT("Windows XP Visual Style Test"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 	CW_USEDEFAULT,
		350, 150,
		NULL, 
		NULL, 
		hInstance, 
		NULL);

	if(!g_hWnd) {
		return FALSE;
	}

	ShowWindow( g_hWnd, nShowCmd);
	UpdateWindow(g_hWnd);

	MSG Msg;
	
	while(GetMessage(&Msg, NULL, 0, 0)) {
		TranslateMessage(&Msg);
		DispatchMessage(&Msg);
	}

	return Msg.wParam;
	
}


//////////////////////////////////////////////////////////////////////////


LRESULT CALLBACK WndProc( HWND hwnd, UINT Msg, WPARAM wParam, LPARAM lParam) {

	switch(Msg) {
	HANDLE_MSG (hwnd, WM_COMMAND, OnCommand );
	HANDLE_MSG(hwnd, WM_CREATE, OnCreate);
	HANDLE_MSG (hwnd, WM_DESTROY, OnDestroy );
	HANDLE_MSG(hwnd, WM_SIZE, OnSize);
	}

	return DefWindowProc(hwnd, Msg, wParam, lParam);
}


///////////////////////////////////////////////////////////////////////////////
//
// Handling WM_COMMAND Message
//


void OnCommand(HWND hwnd, int nID, HWND hWndCtl, UINT codeNotify) {

	if ( IDM_BUTTON1 != nID ) {
		return;
	}
		
	for ( int i=0; i<PROGRESS_MAX_VALUE; i++ ) {
		
		Sleep ( 100 );
		SendMessage(g_hProgressBar, (UINT) PBM_SETPOS,  (WPARAM) i+1, 0);
		
	}
		
}


///////////////////////////////////////////////////////////////////////////////


BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct) {

	// Button
	
	g_hButton = CreateWindowEx (
		0,
		TEXT("Button"),
		(LPTSTR) TEXT("OK"),
		WS_CHILD | WS_VISIBLE, 0, 0, 0, 0,
		hwnd, (HMENU) IDM_BUTTON1,
		NULL, NULL );

	// Progress Bar
	
	InitCommonControls ();

	g_hProgressBar = CreateWindowEx(
		0, 
		PROGRESS_CLASS,
		(LPTSTR) NULL, 
		WS_CHILD | WS_VISIBLE,
		0, 0, 0,0, 
		hwnd, (HMENU) IDM_PROGRESSBAR1,
		NULL, NULL); 

	SendMessage ( 
		g_hProgressBar,
		(UINT) PBM_SETRANGE,	
		(WPARAM) 0,
		(LPARAM) MAKELPARAM (0, PROGRESS_MAX_VALUE) );

	// Show Windows
	
	ShowWindow ( g_hButton, SW_SHOW );
	ShowWindow ( g_hProgressBar, SW_SHOW );

	return TRUE;
}


///////////////////////////////////////////////////////////////////////////////


void OnDestroy ( HWND hwnd ) {

	PostQuitMessage(0);

}

///////////////////////////////////////////////////////////////////////////////


void OnSize(HWND hwnd, UINT state, int cx, int cy) {

	MoveWindow ( 
		g_hButton, 
		10, // left 
		20, // top, 
		100, // width
		30, // height
		TRUE );

	MoveWindow (
		g_hProgressBar,
		10, 
		60,
		300,
		20,
		TRUE);

}
